#include <NmraDcc.h>

#include "EEPROM.h"


NmraDcc  Dcc ;
DCC_MSG  Packet ;

// signal DCC sur l'entrée 2

int adresse;
int adressed;
int adresseu;
int ma;
int vitesse;
int vitessed;
int vitesseu;
int octetc;
int B[10];
int fonction1;
int fonction1d;
int fonction1u;
int fonction2;
int fonction2d;
int fonction2u;
int compteur0=0;
int compteur1;
int compteuracc0=0;
int compteuracc1;

long t0=millis();
int adresse0=0;
int compteura=0;
int val;
int tension;


int mode;
int pot;
int dt;
int p=0;
int q=0;
int p90;
int p180;
int pmax;
int c=0;
int ad=0;
int adressedcc;
const float pi = 3.1416;
int n; // nombre de micro-pas par pas
float dn;
byte pos0=0;
byte pos1;
int j;



// Réception des paquets de commande d'accessoires
void notifyDccAccState( uint16_t Addr, uint16_t BoardAddr, uint8_t OutputAddr, uint8_t State)
{
 compteuracc1 = Addr + OutputAddr;
 if (compteuracc1 != compteuracc0 && millis()>t0 + 1000) {
  Serial.print(Addr,DEC) ;
  Serial.println(OutputAddr,DEC) ;
  compteuracc0=compteuracc1;
  t0=millis();
  }

}


// Réception des paquets DCC de commande de locomotives
void notifyDccMsg( DCC_MSG * Msg)
{
 
  for(uint8_t i = 0; i < Msg->Size; i++)
  {
   
    adresse = Msg->Data[0];
    
    if (adresse==adressedcc) {
   ad=1;
    adressed=int(adresse/10);
    adresseu=adresse-10*adressed;
    octetc = Msg->Data[1];
   
            B[7]=int(octetc/128);
            if(B[7]==1) octetc=octetc-128;
            B[6]=int(octetc/64);
            if(B[6]==1) octetc=octetc-64;
            B[5]=int(octetc/32);
            if(B[5]==1) octetc=octetc-32;
            B[4]=int(octetc/16);
            if(B[4]==1) octetc=octetc-16;
            B[3]=int(octetc/8);
            if(B[3]==1) octetc=octetc-8;
            B[2]=int(octetc/4);
            if(B[2]==1) octetc=octetc-4;
            B[1]=int(octetc/2);
            if(B[1]==1) octetc=octetc-2;
            B[0]=int(octetc);
            
            //  vitesse et sens de marche
            if(B[7]==0 && B[6]==1 ) {
            ma=B[5];
             vitesse=B[0]+2*B[1]+4*B[2]+8*B[3];
             vitessed=int(vitesse/10);
             vitesseu=vitesse-10*vitessed;
              
            }
            
             // fonctions du groupe 1
            if(B[7]==1 && B[6]==0 && B[5]==0 ) {
             fonction1=B[0]+2*B[1]+4*B[2]+8*B[3]+16*B[4];
             fonction1d=int(fonction1/10);
             fonction1u=fonction1-10*fonction1d;
            }
             // fonctions du groupe 2
            if(B[7]==1 && B[6]==0 && B[5]==1 && B[4]==1 ) {
             fonction2=B[0]+2*B[1]+4*B[2]+8*B[3];
             fonction2d=int(fonction2/10);
             fonction2u=fonction2-10*fonction2d;
             
            }
            
            // transmission des données au PC 
            compteur1=vitesse;
           
             adresse0=adresse;
             Serial.print(adressed);
             Serial.print(adresseu);
             Serial.print(ma);
             Serial.print(vitessed);
             Serial.print(vitesseu);
             Serial.print(fonction1d);
             Serial.print(fonction1u);
             Serial.print(fonction2d);
             Serial.println(fonction2u);
             adresse=adresseu+10*adressed;
            
            
             
            
          
            
            
         
    }
            
            
            
            
            
  }
 
}





void setup()
{
  Serial.begin(9600);
  pinMode(3, OUTPUT); // connecté à IN1
  pinMode(9, OUTPUT); // connecté à IN2
  pinMode(10, OUTPUT); // connecté à IN3
  pinMode(11, OUTPUT); // connecté à IN4
  pinMode(13, OUTPUT); 

  digitalWrite(13, LOW);  

   pos0=EEPROM.read(1); // lecture de la position enregistrée dans l'EEPROM
   Serial.print("pos=");
   Serial.println(pos0); 
  if (pos0>100) pos0=0;
  pos1=pos0;
  
dt=160; // durée entre 2 pas en ms
p90=100; // nombre de micro-pas pour atteindre 90 degrés
p180=200; // nombre de micro-pas pour atteindre 180 degrés
adressedcc=66; // adresse du décodeur DCC entre 3 et 99
n=4; // nombre de micro-pas par pas
dn=pi/(2*n);

  Serial.println("NMRA DCC Example 1");
  // Call the main DCC Init function to enable the DCC Receiver
  Dcc.init( MAN_ID_DIY, 10, FLAGS_OUTPUT_ADDRESS_MODE | FLAGS_DCC_ACCESSORY_DECODER | FLAGS_ENABLE_INT0_PULL_UP, 0 );
  Serial.println("Init Done");
}

void loop()
{

  




Dcc.process();



if (ad==1)  digitalWrite(13, HIGH); 
if (ad==0)  digitalWrite(13, LOW);

// commande en DCC
if (ad==1 && fonction1==16) pos1=0; // fonction F0
if (ad==1 && fonction1==1 ) pos1=25; // fonction F1
if (ad==1 && fonction1==2)  pos1=50; // fonction F2
if (ad==1 && fonction1==4)  pos1=75; // fonction F3
if (ad==1 && fonction1==8)  pos1=100; // fonction F4

if (ad==1 && fonction1==0 && fonction2==0) {
 digitalWrite(3, LOW);  
 digitalWrite(9, LOW);  
 digitalWrite(10, LOW);  
 digitalWrite(11, LOW);  
}

if (ad==1 && vitesse<5) dt=320;
if (ad==1 && vitesse>=5 && vitesse<10) dt=160;
if (ad==1 && vitesse>=10 ) dt=80;

if (ad==0) {
// commande manuelle par potentiomètre
pot = analogRead(A1); 
if (pot<400) pos1=0; // position 0 degré
if (pot>400 && pot<800) pos1=25; // position 90 degrés
if (pot>800 ) pos1=50; // position 180 degrés
}

if (pos1>pos0) {
 for (int j=pos0; j <=pos1; j++){
    for (int i=0; i <n; i++){
 analogWrite(3, (int)(255*sin(pi/2+dn*i)));  
 analogWrite(9, 0);  
 analogWrite(10, (int)( 255*sin(dn*i)));  
 analogWrite(11, 0);
 delay(dt/n); 
 }      

 
       for (int i=0; i <n; i++){
 analogWrite(3, 0);  
 analogWrite(9, (int)( 255*sin(dn*i)));  
 analogWrite(10, (int)(255*sin(pi/2+dn*i)));  
 analogWrite(11, 0);
 delay(dt/n); 
 }        

 
  for (int i=0; i <n; i++){
 analogWrite(3, 0);  
 analogWrite(9,  (int)(255*sin(pi/2+dn*i)));  
 analogWrite(10, 0);  
 analogWrite(11, (int)(255*sin(dn*i))); 
 delay(dt/n); 
 }         

 
  for (int i=0; i <n; i++){
 analogWrite(3, (int)(255*sin(dn*i)));  
 analogWrite(9, 0);  
 analogWrite(10, 0);  
 analogWrite(11, (int)(255*sin(pi/2+dn*i))); 
 delay(dt/n); 
 }        

 
 Serial.println(j);   
 }
 pos0=pos1;
 Serial.print("pos=");
 Serial.println(pos0); 
 EEPROM.write(1, pos0);  // enregistrement de la position dans l'EEPROM
 digitalWrite(3, LOW);  
 digitalWrite(9, LOW);  
 digitalWrite(10, LOW);  
 digitalWrite(11, LOW);  
 }

 if (pos1<pos0) {

 for (int j=pos0; j >=pos1; j=j-1){ 
   for (int i=0; i <n; i++){
 analogWrite(3, 0);  
 analogWrite(9, (int)(255*sin(dn*i)));  
 analogWrite(10, 0);  
 analogWrite(11, (int)(255*sin(pi/2+dn*i)));
 delay(dt/n); 
 }   
 
for (int i=0; i <n; i++){
 analogWrite(3, 0);  
 analogWrite(9, (int)(255*sin(pi/2+dn*i)));  
 analogWrite(10, (int)(255*sin(dn*i)));  
 analogWrite(11, 0);
 delay(dt/n); 
 }     
 
 for (int i=0; i <n; i++){
 analogWrite(3, (int)(255*sin(dn*i)));  
 analogWrite(9, 0);  
 analogWrite(10, (int)(255*sin(pi/2+dn*i)));  
 analogWrite(11, 0);
 delay(dt/n); 
 }      


for (int i=0; i <n; i++){
 analogWrite(3, (int)(255*sin(pi/2+dn*i)));  
 analogWrite(9, 0);  
 analogWrite(10, 0);  
 analogWrite(11, (int)(255*sin(dn*i)));
 delay(dt/n); 
 }      
 Serial.println(j);            
 }
 pos0=pos1;
 Serial.print("pos=");
 Serial.println(pos0);  
 EEPROM.write(1, pos0);
 digitalWrite(3, LOW);  
 digitalWrite(9, LOW);  
 digitalWrite(10, LOW);  
 digitalWrite(11, LOW);     
 }

 







}
